//include picture stuff
#include <nostub.h>      // necessary for the nostub stuff
#include <gray.h>        // for the grayscale routines
#include <kbd.h>         // for ngetchx()
#include <graph.h>       // for LCD_WIDTH definition
#include <compat.h>      // for the TI89 definition
#include <mem.h>         // for memset() and memcpy()

//include the header files
#include "Lenin.h"
#include "Stalin.h"
#include "malenkov.h"
#include "leonid.h"
#include "gorbachev.h"
#include "Khruschev.h"

//the big mighty include
#include <tigcclib.h> //tigcc include

//define much for the picture
#define SAVE_SCREEN      // restore screen after program end
#define USE_GRAY_PATCH   // use grayscale patch

//things
int _ti92plus;          // needed to produce ti92plus code
int _ti89;              // needed to produce ti89 code

void _main(void) {
    //Lenin
    unsigned char* plane1;
    unsigned char* plane2;
    unsigned char* dest1;
    unsigned char* dest2;
    unsigned char* src1;
    unsigned char* src2;
    int            loop;

    if (!GrayMode(GRAY_ON)) {
        return;
    }


    plane1 = GetPlane(0);
    plane2 = GetPlane(1);



    dest1 = plane1;
    dest2 = plane2;
    src1  = lenin;
    src2  = lenin2;


    if (!TI89) {
        memset(plane1,0,LCD_SIZE);
        memset(plane2,0,LCD_SIZE);


        dest1 += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2 += ((128-100)*30)/2 + ((240-160)/8)/2;
    }


    for (loop=0;loop<100;loop++,src1+=20,src2+=20,dest1+=30,dest2+=30) {
        memcpy(dest1,src1,20);
        memcpy(dest2,src2,20);
    }
    

    ngetchx();
    
    //Stalin
    clrscr();
    unsigned char* plane1a;
    unsigned char* plane2a;
    unsigned char* dest1a;
    unsigned char* dest2a;
    unsigned char* src1a;
    unsigned char* src2a;
    int            loopa;

    if (!GrayMode(GRAY_ON)) {
        return;
    }


    plane1a = GetPlane(0);
    plane2a = GetPlane(1);



    dest1a = plane1;
    dest2a = plane2;
    src1a  = stalin;
    src2a  = stalin2;


    if (!TI89) {
        memset(plane1a,0,LCD_SIZE);
        memset(plane2a,0,LCD_SIZE);


        dest1 += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2 += ((128-100)*30)/2 + ((240-160)/8)/2;
    }


    for (loop=0;loop<100;loop++,src1a+=20,src2a+=20,dest1a+=30,dest2a+=30) {
        memcpy(dest1a,src1a,20);
        memcpy(dest2a,src2a,20);
    }
    
    ngetchx();
    
    //Malenkov
    unsigned char* plane1b;
    unsigned char* plane2b;
    unsigned char* dest1b;
    unsigned char* dest2b;
    unsigned char* src1b;
    unsigned char* src2b;
    int            loopb;

    if (!GrayMode(GRAY_ON)) {
        return;
    }


    plane1b = GetPlane(0);
    plane2b = GetPlane(1);



    dest1b = plane1b;
    dest2b = plane2b;
    src1b  = malenkov;
    src2b  = malenkov2;


    if (!TI89) {
        memset(plane1b,0,LCD_SIZE);
        memset(plane2b,0,LCD_SIZE);


        dest1b += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2b += ((128-100)*30)/2 + ((240-160)/8)/2;
    }


    for (loop=0;loop<100;loop++,src1b+=20,src2b+=20,dest1b+=30,dest2b+=30) {
        memcpy(dest1b,src1b,20);
        memcpy(dest2b,src2b,20);
    }
    
     ngetchx();
     
    //Khruschev 
    unsigned char* plane1e;
    unsigned char* plane2e;
    unsigned char* dest1e;
    unsigned char* dest2e;
    unsigned char* src1e;
    unsigned char* src2e;
    int            loope;

    if (!GrayMode(GRAY_ON)) {
        return;
    }


    plane1e = GetPlane(0);
    plane2e = GetPlane(1);



    dest1e = plane1e;
    dest2e = plane2e;
    src1e  = khruschev;
    src2e  = khruschev2;


    if (!TI89) {
        memset(plane1e,0,LCD_SIZE);
        memset(plane2e,0,LCD_SIZE);


        dest1e += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2e += ((128-100)*30)/2 + ((240-160)/8)/2;
    }


    for (loop=0;loop<100;loop++,src1e+=20,src2e+=20,dest1e+=30,dest2e+=30) {
        memcpy(dest1e,src1e,20);
        memcpy(dest2e,src2e,20);
    }
    

    ngetchx();
    
    //Brezhnev 
     clrscr();
     
    unsigned char* plane1c;
    unsigned char* plane2c;
    
    unsigned char* dest1c;
    unsigned char* dest2c;
    
    unsigned char* src1c;
    unsigned char* src2c;
  
    int            loopc;

    if (!GrayMode(GRAY_ON)) {
        return;
    }


    plane1c = GetPlane(0);
    plane2c = GetPlane(1);


    dest1c = plane1c;
    dest2c = plane2c;
    src1c  = brezhnev;
    src2c  = brezhnev2;
  


    if (!TI89) {
        memset(plane1c,0,LCD_SIZE);
        memset(plane2c,0,LCD_SIZE);
     


        dest1c += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2c += ((128-100)*30)/2 + ((240-160)/8)/2;
     
    }


    for (loop=0;loop<100;loop++,src1c+=20,src2c+=20,dest1c+=30,dest2c+=30) {
        memcpy(dest1c,src1c,20);
        memcpy(dest2c,src2c,20);
        
    }
    
    ngetchx();
    
    //Gorbachev
    unsigned char* plane1d;
    unsigned char* plane2d;
    unsigned char* dest1d;
    unsigned char* dest2d;
    unsigned char* src1d;
    unsigned char* src2d;
    int            loopd;

    if (!GrayMode(GRAY_ON)) {
        return;
    }


    plane1d = GetPlane(0);
    plane2d = GetPlane(1);



    dest1d = plane1d;
    dest2d = plane2d;
    src1d  = gorbachev;
    src2d  = gorbachev2;


    if (!TI89) {
        memset(plane1d,0,LCD_SIZE);
        memset(plane2d,0,LCD_SIZE);


        dest1d += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2d += ((128-100)*30)/2 + ((240-160)/8)/2;
    }


    for (loop=0;loop<100;loop++,src1d+=20,src2d+=20,dest1d+=30,dest2d+=30) {
        memcpy(dest1d,src1d,20);
        memcpy(dest2d,src2d,20);
    }
    
    ngetchx();
    
    
    GrayMode(GRAY_OFF);
}

